//#line 2 "/opt/ros/diamondback/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the visp_tracker package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __visp_tracker__MOVINGEDGECONFIG_H__
#define __visp_tracker__MOVINGEDGECONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace visp_tracker
{
  class MovingEdgeConfigStatics;
  
  class MovingEdgeConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(MovingEdgeConfig &config, const MovingEdgeConfig &max, const MovingEdgeConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const MovingEdgeConfig &config1, const MovingEdgeConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, MovingEdgeConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const MovingEdgeConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, MovingEdgeConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const MovingEdgeConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T MovingEdgeConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (MovingEdgeConfig::* field);

      virtual void clamp(MovingEdgeConfig &config, const MovingEdgeConfig &max, const MovingEdgeConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const MovingEdgeConfig &config1, const MovingEdgeConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, MovingEdgeConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const MovingEdgeConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, MovingEdgeConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const MovingEdgeConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 12 "../cfg/MovingEdge.cfg"
      int mask_size;
//#line 13 "../cfg/MovingEdge.cfg"
      int n_mask;
//#line 15 "../cfg/MovingEdge.cfg"
      int range;
//#line 16 "../cfg/MovingEdge.cfg"
      double threshold;
//#line 18 "../cfg/MovingEdge.cfg"
      double mu1;
//#line 19 "../cfg/MovingEdge.cfg"
      double mu2;
//#line 21 "../cfg/MovingEdge.cfg"
      double sample_step;
//#line 22 "../cfg/MovingEdge.cfg"
      int ntotal_sample;
//#line 24 "../cfg/MovingEdge.cfg"
      int strip;
//#line 25 "../cfg/MovingEdge.cfg"
      double min_samplestep;
//#line 26 "../cfg/MovingEdge.cfg"
      double aberration;
//#line 27 "../cfg/MovingEdge.cfg"
      double init_aberration;
//#line 35 "../cfg/MovingEdge.cfg"
      double lambda;
//#line 36 "../cfg/MovingEdge.cfg"
      double first_threshold;
//#line 138 "/opt/ros/diamondback/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("MovingEdgeConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const MovingEdgeConfig &__max__ = __getMax__();
      const MovingEdgeConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const MovingEdgeConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const MovingEdgeConfig &__getDefault__();
    static const MovingEdgeConfig &__getMax__();
    static const MovingEdgeConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const MovingEdgeConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void MovingEdgeConfig::ParamDescription<std::string>::clamp(MovingEdgeConfig &config, const MovingEdgeConfig &max, const MovingEdgeConfig &min) const
  {
    return;
  }

  class MovingEdgeConfigStatics
  {
    friend class MovingEdgeConfig;
    
    MovingEdgeConfigStatics()
    {
//#line 12 "../cfg/MovingEdge.cfg"
      __min__.mask_size = 0;
//#line 12 "../cfg/MovingEdge.cfg"
      __max__.mask_size = 15;
//#line 12 "../cfg/MovingEdge.cfg"
      __default__.mask_size = 7;
//#line 12 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<int>("mask_size", "int", 0, "mask size", "", &MovingEdgeConfig::mask_size)));
//#line 13 "../cfg/MovingEdge.cfg"
      __min__.n_mask = 0;
//#line 13 "../cfg/MovingEdge.cfg"
      __max__.n_mask = 500;
//#line 13 "../cfg/MovingEdge.cfg"
      __default__.n_mask = 180;
//#line 13 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<int>("n_mask", "int", 0, "number of masks", "", &MovingEdgeConfig::n_mask)));
//#line 15 "../cfg/MovingEdge.cfg"
      __min__.range = 0;
//#line 15 "../cfg/MovingEdge.cfg"
      __max__.range = 50;
//#line 15 "../cfg/MovingEdge.cfg"
      __default__.range = 5;
//#line 15 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<int>("range", "int", 0, "range", "", &MovingEdgeConfig::range)));
//#line 16 "../cfg/MovingEdge.cfg"
      __min__.threshold = 0.0;
//#line 16 "../cfg/MovingEdge.cfg"
      __max__.threshold = 5000.0;
//#line 16 "../cfg/MovingEdge.cfg"
      __default__.threshold = 2000.0;
//#line 16 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<double>("threshold", "double", 0, "threshold", "", &MovingEdgeConfig::threshold)));
//#line 18 "../cfg/MovingEdge.cfg"
      __min__.mu1 = 0.0;
//#line 18 "../cfg/MovingEdge.cfg"
      __max__.mu1 = 1.0;
//#line 18 "../cfg/MovingEdge.cfg"
      __default__.mu1 = 0.5;
//#line 18 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<double>("mu1", "double", 0, "contrast continuity (mu1)", "", &MovingEdgeConfig::mu1)));
//#line 19 "../cfg/MovingEdge.cfg"
      __min__.mu2 = 0.0;
//#line 19 "../cfg/MovingEdge.cfg"
      __max__.mu2 = 1.0;
//#line 19 "../cfg/MovingEdge.cfg"
      __default__.mu2 = 0.5;
//#line 19 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<double>("mu2", "double", 0, "contrast continuity (mu2)", "", &MovingEdgeConfig::mu2)));
//#line 21 "../cfg/MovingEdge.cfg"
      __min__.sample_step = 0.0;
//#line 21 "../cfg/MovingEdge.cfg"
      __max__.sample_step = 50.0;
//#line 21 "../cfg/MovingEdge.cfg"
      __default__.sample_step = 1.0;
//#line 21 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<double>("sample_step", "double", 0, "sample step", "", &MovingEdgeConfig::sample_step)));
//#line 22 "../cfg/MovingEdge.cfg"
      __min__.ntotal_sample = 0;
//#line 22 "../cfg/MovingEdge.cfg"
      __max__.ntotal_sample = 10000;
//#line 22 "../cfg/MovingEdge.cfg"
      __default__.ntotal_sample = 1000;
//#line 22 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<int>("ntotal_sample", "int", 0, "total samples number", "", &MovingEdgeConfig::ntotal_sample)));
//#line 24 "../cfg/MovingEdge.cfg"
      __min__.strip = 0;
//#line 24 "../cfg/MovingEdge.cfg"
      __max__.strip = 10;
//#line 24 "../cfg/MovingEdge.cfg"
      __default__.strip = 2;
//#line 24 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<int>("strip", "int", 0, "strip", "", &MovingEdgeConfig::strip)));
//#line 25 "../cfg/MovingEdge.cfg"
      __min__.min_samplestep = 0.0;
//#line 25 "../cfg/MovingEdge.cfg"
      __max__.min_samplestep = 50.0;
//#line 25 "../cfg/MovingEdge.cfg"
      __default__.min_samplestep = 4.0;
//#line 25 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<double>("min_samplestep", "double", 0, "min sample step", "", &MovingEdgeConfig::min_samplestep)));
//#line 26 "../cfg/MovingEdge.cfg"
      __min__.aberration = 0.0;
//#line 26 "../cfg/MovingEdge.cfg"
      __max__.aberration = 10.0;
//#line 26 "../cfg/MovingEdge.cfg"
      __default__.aberration = 2.0;
//#line 26 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<double>("aberration", "double", 0, "aberration", "", &MovingEdgeConfig::aberration)));
//#line 27 "../cfg/MovingEdge.cfg"
      __min__.init_aberration = 0.0;
//#line 27 "../cfg/MovingEdge.cfg"
      __max__.init_aberration = 10.0;
//#line 27 "../cfg/MovingEdge.cfg"
      __default__.init_aberration = 5.0;
//#line 27 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<double>("init_aberration", "double", 0, "init aberration", "", &MovingEdgeConfig::init_aberration)));
//#line 35 "../cfg/MovingEdge.cfg"
      __min__.lambda = 0.0;
//#line 35 "../cfg/MovingEdge.cfg"
      __max__.lambda = 1.0;
//#line 35 "../cfg/MovingEdge.cfg"
      __default__.lambda = 1.0;
//#line 35 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<double>("lambda", "double", 0, "lambda (mbt)", "", &MovingEdgeConfig::lambda)));
//#line 36 "../cfg/MovingEdge.cfg"
      __min__.first_threshold = 0.0;
//#line 36 "../cfg/MovingEdge.cfg"
      __max__.first_threshold = 1.0;
//#line 36 "../cfg/MovingEdge.cfg"
      __default__.first_threshold = 0.4;
//#line 36 "../cfg/MovingEdge.cfg"
      __param_descriptions__.push_back(MovingEdgeConfig::AbstractParamDescriptionConstPtr(new MovingEdgeConfig::ParamDescription<double>("first_threshold", "double", 0, "init threshold (mbt)", "", &MovingEdgeConfig::first_threshold)));
//#line 239 "/opt/ros/diamondback/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<MovingEdgeConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<MovingEdgeConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    MovingEdgeConfig __max__;
    MovingEdgeConfig __min__;
    MovingEdgeConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const MovingEdgeConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static MovingEdgeConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &MovingEdgeConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const MovingEdgeConfig &MovingEdgeConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const MovingEdgeConfig &MovingEdgeConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const MovingEdgeConfig &MovingEdgeConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<MovingEdgeConfig::AbstractParamDescriptionConstPtr> &MovingEdgeConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const MovingEdgeConfigStatics *MovingEdgeConfig::__get_statics__()
  {
    const static MovingEdgeConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = MovingEdgeConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __MOVINGEDGERECONFIGURATOR_H__
