"""autogenerated by genmsg_py from TrackingResult.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import std_msgs.msg

class TrackingResult(roslib.message.Message):
  _md5sum = "28f4ec1798d336df9f5ec5fb0f9f13b2"
  _type = "visp_tracker/TrackingResult"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# Object pose at a particular point of time.
#
# If the tracking fails (is_tracking is false), the
# cMo attribute value can be anything and must be ignored.

Header header               # Header (required for synchornization).
bool is_tracking            # Did the tracking succeed?
geometry_msgs/Transform cMo # Object pose (translation and quaternion).

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['header','is_tracking','cMo']
  _slot_types = ['Header','bool','geometry_msgs/Transform']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,is_tracking,cMo
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(TrackingResult, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.is_tracking is None:
        self.is_tracking = False
      if self.cMo is None:
        self.cMo = geometry_msgs.msg.Transform()
    else:
      self.header = std_msgs.msg._Header.Header()
      self.is_tracking = False
      self.cMo = geometry_msgs.msg.Transform()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B7d.pack(_x.is_tracking, _x.cMo.translation.x, _x.cMo.translation.y, _x.cMo.translation.z, _x.cMo.rotation.x, _x.cMo.rotation.y, _x.cMo.rotation.z, _x.cMo.rotation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.cMo is None:
        self.cMo = geometry_msgs.msg.Transform()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 57
      (_x.is_tracking, _x.cMo.translation.x, _x.cMo.translation.y, _x.cMo.translation.z, _x.cMo.rotation.x, _x.cMo.rotation.y, _x.cMo.rotation.z, _x.cMo.rotation.w,) = _struct_B7d.unpack(str[start:end])
      self.is_tracking = bool(self.is_tracking)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B7d.pack(_x.is_tracking, _x.cMo.translation.x, _x.cMo.translation.y, _x.cMo.translation.z, _x.cMo.rotation.x, _x.cMo.rotation.y, _x.cMo.rotation.z, _x.cMo.rotation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.cMo is None:
        self.cMo = geometry_msgs.msg.Transform()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 57
      (_x.is_tracking, _x.cMo.translation.x, _x.cMo.translation.y, _x.cMo.translation.z, _x.cMo.rotation.x, _x.cMo.rotation.y, _x.cMo.rotation.z, _x.cMo.rotation.w,) = _struct_B7d.unpack(str[start:end])
      self.is_tracking = bool(self.is_tracking)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_B7d = struct.Struct("<B7d")
