"""autogenerated by genmsg_py from InitRequest.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import visp_tracker.msg

class InitRequest(roslib.message.Message):
  _md5sum = "440a9fdc3875f06ac1d9d7ab02a58456"
  _type = "visp_tracker/InitRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """








geometry_msgs/Transform initial_cMo


MovingEdge moving_edge

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: visp_tracker/MovingEdge
# This message contains tracking parameters.
#
# These parameters determine how precise, how fast and how
# reliable will be the tracking.
#
# It should be tuned carefully and can be changed dynamically.
#
# For more details, see the ViSP documentation:
# http://www.irisa.fr/lagadic/visp/publication.html


# Moving edge parameters.

int64 mask_size    # Mask size (in pixel) used to compute the image gradient
                   # and determine the object contour.
		   # A larger mask size is better for larger images.
		   # 3 pixels is enough for 640x480 images.
                   # Increasing this value makes the tracking slower.
		   #
		   # Caution: this value cannot be changed dynamically
		   # without resetting the tracking.

int64 n_mask       # Number of masks applied to determine the object contour.
                   # Increasing this value makes the tracking slower.

int64 range        # Maximum seek distance on both sides of the reference pixel.
      		   # It should match the maximum distance in pixel between
		   # the current position of the feature projection and
		   # its next position.
		   # I.e. if the object moves fast and your tracking
		   # frequency is low, this value should be increased.
                   # Increasing this value makes the tracking slower.

float64 threshold  # Value used to determine if a moving edge is valid
		   # or not.

float64 mu1        # Minimum image contrast allowed to detect a contour.
float64 mu2        # Maximum image contrast allowed to detect a contour.

int64 sample_step   # Minimum distance in pixel between two
      		    # discretization points.
      		    # It avoids having too many discretization points when
		    # the tracked object is far away (and its projection
		    # in the image is small).
		    # Increasing this value makes the tracking *faster*.

int64 ntotal_sample # How many discretization points are used to track the
      		    # feature.
		    # Higher is better but slow down the tracking.
		    # The best value depends on your model and its distance
		    # with respect to the camera.
		    # Increasing this value makes the tracking slower.

int64 strip             # How many pixels are ignored around the borders.
float64 min_samplestep  # Minimum allowed samplestep. Useful to specify
			# a lower bound when the samplestep is changed
			# dynamically.
			# This is not done by visp_tracker currently.
float64 aberration      # Ignored.
float64 init_aberration # Ignored.


# Tracker parameters.

float64 lambda          # Gain used to compute the control law.
float64 first_threshold # What proportion of points should be valid to
                        # acccept an initial pose.
			# Value should be between 0 et 1.

"""
  __slots__ = ['initial_cMo','moving_edge']
  _slot_types = ['geometry_msgs/Transform','visp_tracker/MovingEdge']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       initial_cMo,moving_edge
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(InitRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.initial_cMo is None:
        self.initial_cMo = geometry_msgs.msg.Transform()
      if self.moving_edge is None:
        self.moving_edge = visp_tracker.msg.MovingEdge()
    else:
      self.initial_cMo = geometry_msgs.msg.Transform()
      self.moving_edge = visp_tracker.msg.MovingEdge()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_7d3q3d3q5d.pack(_x.initial_cMo.translation.x, _x.initial_cMo.translation.y, _x.initial_cMo.translation.z, _x.initial_cMo.rotation.x, _x.initial_cMo.rotation.y, _x.initial_cMo.rotation.z, _x.initial_cMo.rotation.w, _x.moving_edge.mask_size, _x.moving_edge.n_mask, _x.moving_edge.range, _x.moving_edge.threshold, _x.moving_edge.mu1, _x.moving_edge.mu2, _x.moving_edge.sample_step, _x.moving_edge.ntotal_sample, _x.moving_edge.strip, _x.moving_edge.min_samplestep, _x.moving_edge.aberration, _x.moving_edge.init_aberration, _x.moving_edge.lambda, _x.moving_edge.first_threshold))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.initial_cMo is None:
        self.initial_cMo = geometry_msgs.msg.Transform()
      if self.moving_edge is None:
        self.moving_edge = visp_tracker.msg.MovingEdge()
      end = 0
      _x = self
      start = end
      end += 168
      (_x.initial_cMo.translation.x, _x.initial_cMo.translation.y, _x.initial_cMo.translation.z, _x.initial_cMo.rotation.x, _x.initial_cMo.rotation.y, _x.initial_cMo.rotation.z, _x.initial_cMo.rotation.w, _x.moving_edge.mask_size, _x.moving_edge.n_mask, _x.moving_edge.range, _x.moving_edge.threshold, _x.moving_edge.mu1, _x.moving_edge.mu2, _x.moving_edge.sample_step, _x.moving_edge.ntotal_sample, _x.moving_edge.strip, _x.moving_edge.min_samplestep, _x.moving_edge.aberration, _x.moving_edge.init_aberration, _x.moving_edge.lambda, _x.moving_edge.first_threshold,) = _struct_7d3q3d3q5d.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_7d3q3d3q5d.pack(_x.initial_cMo.translation.x, _x.initial_cMo.translation.y, _x.initial_cMo.translation.z, _x.initial_cMo.rotation.x, _x.initial_cMo.rotation.y, _x.initial_cMo.rotation.z, _x.initial_cMo.rotation.w, _x.moving_edge.mask_size, _x.moving_edge.n_mask, _x.moving_edge.range, _x.moving_edge.threshold, _x.moving_edge.mu1, _x.moving_edge.mu2, _x.moving_edge.sample_step, _x.moving_edge.ntotal_sample, _x.moving_edge.strip, _x.moving_edge.min_samplestep, _x.moving_edge.aberration, _x.moving_edge.init_aberration, _x.moving_edge.lambda, _x.moving_edge.first_threshold))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.initial_cMo is None:
        self.initial_cMo = geometry_msgs.msg.Transform()
      if self.moving_edge is None:
        self.moving_edge = visp_tracker.msg.MovingEdge()
      end = 0
      _x = self
      start = end
      end += 168
      (_x.initial_cMo.translation.x, _x.initial_cMo.translation.y, _x.initial_cMo.translation.z, _x.initial_cMo.rotation.x, _x.initial_cMo.rotation.y, _x.initial_cMo.rotation.z, _x.initial_cMo.rotation.w, _x.moving_edge.mask_size, _x.moving_edge.n_mask, _x.moving_edge.range, _x.moving_edge.threshold, _x.moving_edge.mu1, _x.moving_edge.mu2, _x.moving_edge.sample_step, _x.moving_edge.ntotal_sample, _x.moving_edge.strip, _x.moving_edge.min_samplestep, _x.moving_edge.aberration, _x.moving_edge.init_aberration, _x.moving_edge.lambda, _x.moving_edge.first_threshold,) = _struct_7d3q3d3q5d.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_7d3q3d3q5d = struct.Struct("<7d3q3d3q5d")
"""autogenerated by genmsg_py from InitResponse.msg. Do not edit."""
import roslib.message
import struct


class InitResponse(roslib.message.Message):
  _md5sum = "8e1a436e960986e0760f2970d0c88bf4"
  _type = "visp_tracker/InitResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
bool initialization_succeed


"""
  __slots__ = ['initialization_succeed']
  _slot_types = ['bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       initialization_succeed
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(InitResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.initialization_succeed is None:
        self.initialization_succeed = False
    else:
      self.initialization_succeed = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      buff.write(_struct_B.pack(self.initialization_succeed))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 1
      (self.initialization_succeed,) = _struct_B.unpack(str[start:end])
      self.initialization_succeed = bool(self.initialization_succeed)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      buff.write(_struct_B.pack(self.initialization_succeed))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.initialization_succeed,) = _struct_B.unpack(str[start:end])
      self.initialization_succeed = bool(self.initialization_succeed)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_B = struct.Struct("<B")
class Init(roslib.message.ServiceDefinition):
  _type          = 'visp_tracker/Init'
  _md5sum = 'd9f7c7c2435e9d0af6283a1aac362aac'
  _request_class  = InitRequest
  _response_class = InitResponse
